<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: png/writedatapng2.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_faf003682c2bcfc217df395c6fafe5c7.html">png</a>
  </div>
</div>
<div class="contents">
<h1>writedatapng2.c</h1><a href="writedatapng2_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: writedatapng.c 1246 2008-01-30 18:50:24Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="writepng_8h.html">writepng.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">static</span> <span class="keywordtype">int</span>  doinit=1;
<a name="l00031"></a>00031 <span class="keyword">static</span> <span class="keywordtype">int</span>  fieldon=0;
<a name="l00032"></a>00032 <span class="keyword">static</span> <span class="keywordtype">int</span>  pix[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];   
<a name="l00033"></a>00033 <span class="keyword">static</span> Mat  Afe2sq;    
<a name="l00034"></a>00034 <span class="keyword">static</span> Vec  VIpol;     
<a name="l00037"></a><a class="code" href="writepng_8h.html#a916a4d7d0d8aec0eac742e8f8bb41a93">00037</a> <span class="keywordtype">int</span> <a class="code" href="writedatapng2_8c.html#a916a4d7d0d8aec0eac742e8f8bb41a93">WritePNG2init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="keywordtype">int</span> rank,size;
<a name="l00042"></a>00042   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00043"></a>00043   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="keywordtype">int</span>         nmax;
<a name="l00046"></a>00046   PetscTruth  flg;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   PetscReal slice_n[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00049"></a>00049   nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00050"></a>00050   ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-slice2_n&quot;</span>,slice_n,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00051"></a>00051   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00052"></a>00052     slice_n[0]=slice_n[1]=0;slice_n[2]=1;
<a name="l00053"></a>00053     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00054"></a>00054       <span class="stringliteral">&quot;Option -slice2_n not found, using default value: (%g,%g,%g)\n&quot;</span>,
<a name="l00055"></a>00055       slice_n[0],slice_n[1],slice_n[2]
<a name="l00056"></a>00056     );
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nmax!=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>) {
<a name="l00059"></a>00059     SETERRQ(PETSC_ERR_ARG_INCOMP,
<a name="l00060"></a>00060       <span class="stringliteral">&quot;Wrong number of values for option -slice2_n!\n&quot;</span>);
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   PetscReal slice_p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00064"></a>00064   nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00065"></a>00065   ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-slice2_p&quot;</span>,slice_p,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00066"></a>00066   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00067"></a>00067     slice_p[0]=slice_p[1]=slice_p[2]=PETSC_MAX;
<a name="l00068"></a>00068     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00069"></a>00069       <span class="stringliteral">&quot;Option -slice2_p not found, using default value: (%g,%g,%g)\n&quot;</span>,
<a name="l00070"></a>00070       slice_p[0],slice_p[1],slice_p[2]
<a name="l00071"></a>00071     );
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;PNG output off\n&quot;</span>);
<a name="l00074"></a>00074     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00075"></a>00075   }
<a name="l00076"></a>00076   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nmax!=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>) {
<a name="l00077"></a>00077     SETERRQ(PETSC_ERR_ARG_INCOMP,
<a name="l00078"></a>00078       <span class="stringliteral">&quot;Wrong number of values for option -slice2_p!\n&quot;</span>);
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="keywordtype">int</span> slice_g;
<a name="l00082"></a>00082   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-slice2_g&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;slice_g,&amp;flg);CHKERRQ(ierr);
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00084"></a>00084     slice_g=0;
<a name="l00085"></a>00085     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00086"></a>00086       <span class="stringliteral">&quot;Option -slice2_g not found, using default value: %i\n&quot;</span>,
<a name="l00087"></a>00087       slice_g
<a name="l00088"></a>00088     );
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090   <span class="keywordflow">if</span> (PetscAbsInt(slice_g)&gt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) {
<a name="l00091"></a>00091     SETERRQ(PETSC_ERR_ARG_INCOMP,
<a name="l00092"></a>00092       <span class="stringliteral">&quot;slice2_g &gt; number property ids\n&quot;</span>);
<a name="l00093"></a>00093   }
<a name="l00094"></a>00094   <span class="keywordflow">if</span> (slice_g==0) {
<a name="l00095"></a>00095     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00096"></a>00096       <span class="stringliteral">&quot;slice2_g == 0: drawing magnetization of any volume\n&quot;</span>
<a name="l00097"></a>00097     );
<a name="l00098"></a>00098   }
<a name="l00099"></a>00099   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (slice_g&lt;0) {
<a name="l00100"></a>00100     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00101"></a>00101       <span class="stringliteral">&quot;slice2_g &lt; 0: drawing magnetization of any volume except pid %i\n&quot;</span>,
<a name="l00102"></a>00102       slice_g
<a name="l00103"></a>00103     );
<a name="l00104"></a>00104   }
<a name="l00105"></a>00105   <span class="keywordflow">else</span> {
<a name="l00106"></a>00106     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00107"></a>00107       <span class="stringliteral">&quot;slice2_g &gt; 0: drawing only magnetization of volumes with pid %i\n&quot;</span>,
<a name="l00108"></a>00108       slice_g
<a name="l00109"></a>00109     );
<a name="l00110"></a>00110   }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keywordtype">int</span> res;
<a name="l00113"></a>00113   ierr = PetscOptionsGetInt (PETSC_NULL,<span class="stringliteral">&quot;-res&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;res,&amp;flg);CHKERRQ(ierr);
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00115"></a>00115     res=50;
<a name="l00116"></a>00116     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00117"></a>00117       <span class="stringliteral">&quot;Option -res not found, using default value: %i\n&quot;</span>,
<a name="l00118"></a>00118       res
<a name="l00119"></a>00119     );
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;shift and tilt to avoid cutting &#39;between&#39; elements\n&quot;</span>);
<a name="l00123"></a>00123 <span class="preprocessor">#define DIST 1e-12</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>  slice_p[0]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;slice_n[0]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00125"></a>00125   slice_p[1]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;slice_n[1]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00126"></a>00126   slice_p[2]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;slice_n[2]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00127"></a>00127   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0+<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>,slice_n,1);
<a name="l00128"></a>00128   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0+<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>,slice_p,1);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   PetscReal *vertxyz2;
<a name="l00131"></a>00131   PetscReal axes2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00132"></a>00132   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;vertxyz2);CHKERRQ(ierr);
<a name="l00133"></a>00133   ierr = <a class="code" href="axesrot_8c.html#a55381bb85270f2885891ae5fcfa61369">AxesRotation</a>(slice_p,slice_n,axes2,0,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,vertxyz2);CHKERRQ(ierr);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">/* find bounding box */</span>
<a name="l00136"></a>00136   slice_g--;
<a name="l00137"></a>00137   PetscReal bbox[2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00138"></a>00138   pix[0]=res;
<a name="l00139"></a>00139   ierr = <a class="code" href="bbox2_8c.html#a2460e21f8005742412b1ac06db34db6e">bbox2</a>(gdata,vertxyz2,1,&amp;slice_g,bbox,pix);CHKERRQ(ierr);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">/* reset z-values to force slice cut through z=0 (vertxyz2 coordinates) */</span>
<a name="l00142"></a>00142   bbox[2]=0;bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+2]=<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   ierr = <a class="code" href="calAfe2sq_8c.html#aa06eabdea2e391822f9b4f13e5ffc35e">CalAfe2sq</a>(gdata,vertxyz2,bbox,pix,slice_g,&amp;Afe2sq);CHKERRQ(ierr);
<a name="l00145"></a>00145   ierr = PetscFree(vertxyz2);CHKERRQ(ierr);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="keywordflow">if</span> (Afe2sq==PETSC_NULL) {
<a name="l00148"></a>00148     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00149"></a>00149   }
<a name="l00150"></a>00150   fieldon=1;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   ierr = VecCreate(PETSC_COMM_WORLD,&amp;VIpol);CHKERRQ(ierr);
<a name="l00153"></a>00153   <span class="keywordflow">if</span> (!rank) {
<a name="l00154"></a>00154     ierr = VecSetSizes(VIpol,
<a name="l00155"></a>00155       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],
<a name="l00156"></a>00156       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1]
<a name="l00157"></a>00157     );CHKERRQ(ierr);
<a name="l00158"></a>00158   }
<a name="l00159"></a>00159   <span class="keywordflow">else</span> {
<a name="l00160"></a>00160     ierr = VecSetSizes(VIpol,0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1]);CHKERRQ(ierr);
<a name="l00161"></a>00161   }
<a name="l00162"></a>00162   ierr = VecSetFromOptions(VIpol);CHKERRQ(ierr);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="writepng_8h.html#aaa844719c96178cd07f858c1192c7341">00168</a> <span class="keywordtype">int</span> <a class="code" href="writedatapng2_8c.html#aaa844719c96178cd07f858c1192c7341">WritePNG2</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00169"></a>00169 {
<a name="l00170"></a>00170   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="keywordtype">int</span> rank,size;
<a name="l00173"></a>00173   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00174"></a>00174   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">if</span> (doinit) {
<a name="l00177"></a>00177     ierr = <a class="code" href="writedatapng2_8c.html#a916a4d7d0d8aec0eac742e8f8bb41a93">WritePNG2init</a>(gdata);CHKERRQ(ierr);
<a name="l00178"></a>00178     doinit=0;
<a name="l00179"></a>00179   }
<a name="l00180"></a>00180   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00181"></a>00181     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   ierr = MatMult(Afe2sq,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,VIpol);CHKERRQ(ierr);
<a name="l00185"></a>00185   <span class="keywordflow">if</span> (rank) {
<a name="l00186"></a>00186     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00187"></a>00187   }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   png_bytepp image;
<a name="l00190"></a>00190   ierr = PetscMalloc(pix[1]*<span class="keyword">sizeof</span>(png_bytep),&amp;image);CHKERRQ(ierr);
<a name="l00191"></a>00191   ierr = PetscMalloc(3*pix[1]*pix[0]*<span class="keyword">sizeof</span>(png_byte),&amp;image[0]);CHKERRQ(ierr);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;pix[1];i++) {
<a name="l00194"></a>00194     image[i] = (png_bytep) (image[0]+3*pix[0]*i);
<a name="l00195"></a>00195     assert(image[i]-image[i-1]==3*pix[0]);
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   PetscReal *a;
<a name="l00199"></a>00199   VecGetArray(VIpol,&amp;a);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00202"></a>00202     <span class="keywordtype">int</span> mcomp;
<a name="l00203"></a>00203 
<a name="l00204"></a>00204     mcomp=k;
<a name="l00205"></a>00205 
<a name="l00206"></a>00206     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;pix[0];i++) {
<a name="l00207"></a>00207       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;pix[1];j++) {
<a name="l00208"></a>00208         png_byte red,green,blue;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210         <span class="comment">/* if the |M|&lt;0.1 then we are outside any magnetic material and</span>
<a name="l00211"></a>00211 <span class="comment">           set the background color white */</span>
<a name="l00212"></a>00212         <span class="keywordflow">if</span> (a[ND*(i*pix[1]+pix[1]-1-j)+0]*a[ND*(i*pix[1]+pix[1]-1-j)+0]+
<a name="l00213"></a>00213             a[ND*(i*pix[1]+pix[1]-1-j)+1]*a[ND*(i*pix[1]+pix[1]-1-j)+1]+
<a name="l00214"></a>00214             a[ND*(i*pix[1]+pix[1]-1-j)+2]*a[ND*(i*pix[1]+pix[1]-1-j)+2]
<a name="l00215"></a>00215             &lt; <a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>
<a name="l00216"></a>00216            ) {
<a name="l00217"></a>00217           red=green=blue=255;
<a name="l00218"></a>00218         }
<a name="l00219"></a>00219         <span class="keywordflow">else</span> {
<a name="l00220"></a>00220           PetscReal t_val;
<a name="l00221"></a>00221           <span class="keywordflow">switch</span>(mcomp) {
<a name="l00222"></a>00222             <span class="keywordflow">case</span> 0:
<a name="l00223"></a>00223               <span class="comment">/* Mx */</span>
<a name="l00224"></a>00224               t_val=a[ND*(i*pix[1]+pix[1]-1-j)+0];
<a name="l00225"></a>00225             <span class="keywordflow">break</span>;
<a name="l00226"></a>00226             <span class="keywordflow">case</span> 1:
<a name="l00227"></a>00227               <span class="comment">/* My */</span>
<a name="l00228"></a>00228               t_val=a[ND*(i*pix[1]+pix[1]-1-j)+1];
<a name="l00229"></a>00229             <span class="keywordflow">break</span>;
<a name="l00230"></a>00230             <span class="keywordflow">case</span> 2:
<a name="l00231"></a>00231               <span class="comment">/* Mz */</span>
<a name="l00232"></a>00232               t_val=a[ND*(i*pix[1]+pix[1]-1-j)+2];
<a name="l00233"></a>00233             <span class="keywordflow">break</span>;
<a name="l00234"></a>00234             <span class="keywordflow">default</span>:
<a name="l00235"></a>00235               SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;mcomp has illegal value\n&quot;</span>);
<a name="l00236"></a>00236             <span class="keywordflow">break</span>;
<a name="l00237"></a>00237           }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239           <span class="comment">/* t_val in [-1,+1] */</span>
<a name="l00240"></a>00240 <span class="comment">/*</span>
<a name="l00241"></a>00241 <span class="comment">          red=  255-(png_byte)((val-vmin)/(vmax-vmin)*255.0);</span>
<a name="l00242"></a>00242 <span class="comment">          green=255-(png_byte)PetscAbsInt((val-(vmax+vmin)/2.0)/(vmax-vmin)*2.0*255.0);</span>
<a name="l00243"></a>00243 <span class="comment">          blue=     (png_byte)((val-vmin)/(vmax-vmin)*255.0);</span>
<a name="l00244"></a>00244 <span class="comment">*/</span>
<a name="l00245"></a>00245 
<a name="l00246"></a>00246           <span class="comment">/* colormap:  -1 ... blue, 0 ... green, 1 ... red */</span>
<a name="l00247"></a>00247           <span class="comment">/* have green in the middle */</span>
<a name="l00248"></a>00248           PetscReal    t_r,t_g,t_b;
<a name="l00249"></a>00249           PetscReal    t_min=-1.0,t_max=+1.0,t_mid=0.5;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251           t_b=(t_val &lt; (t_max+t_min)*t_mid) ?
<a name="l00252"></a>00252             t_val/(-(t_max+t_min)*t_mid+t_min)-
<a name="l00253"></a>00253               (t_max+t_min)*t_mid/(-(t_max+t_min)*t_mid+t_min) :
<a name="l00254"></a>00254             0.0;
<a name="l00255"></a>00255           t_g=(t_val &lt; (t_max+t_min)*t_mid) ?
<a name="l00256"></a>00256             t_val/(+(t_max+t_min)*t_mid-t_min)-
<a name="l00257"></a>00257               t_min/(+(t_max+t_min)*t_mid-t_min) :
<a name="l00258"></a>00258             t_val/(-t_max+(t_max+t_min)*t_mid)-
<a name="l00259"></a>00259               t_max/(-t_max+(t_max+t_min)*t_mid);
<a name="l00260"></a>00260           t_r=(t_val &gt; (t_max+t_min)*t_mid) ?
<a name="l00261"></a>00261             t_val/(t_max-(t_max+t_min)*t_mid)-
<a name="l00262"></a>00262               (t_max+t_min)*t_mid/(t_max-(t_max+t_min)*t_mid) :
<a name="l00263"></a>00263             0.0;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265           <span class="comment">/* fix cases when |M|&gt;1.0 */</span>
<a name="l00266"></a>00266           <span class="keywordflow">if</span> (t_b&gt;1.0) t_b=1.0; <span class="keywordflow">if</span> (t_b&lt;0.0) t_b=0.0;
<a name="l00267"></a>00267           <span class="keywordflow">if</span> (t_g&gt;1.0) t_g=1.0; <span class="keywordflow">if</span> (t_g&lt;0.0) t_g=0.0;
<a name="l00268"></a>00268           <span class="keywordflow">if</span> (t_r&gt;1.0) t_r=1.0; <span class="keywordflow">if</span> (t_r&lt;0.0) t_r=0.0;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270           red=  (png_byte)(t_r*254.0);
<a name="l00271"></a>00271           green=(png_byte)(t_g*254.0);
<a name="l00272"></a>00272           blue= (png_byte)(t_b*254.0);
<a name="l00273"></a>00273         }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 <span class="comment">/*      gcc: comparison is always 1 due to limited range of data type</span>
<a name="l00276"></a>00276 <span class="comment">        assert(red  &gt;=0 &amp;&amp; red   &lt;= 255);</span>
<a name="l00277"></a>00277 <span class="comment">        assert(green&gt;=0 &amp;&amp; green &lt;= 255);</span>
<a name="l00278"></a>00278 <span class="comment">        assert(blue &gt;=0 &amp;&amp; blue  &lt;= 255);</span>
<a name="l00279"></a>00279 <span class="comment">*/</span>
<a name="l00280"></a>00280 
<a name="l00281"></a>00281         image[j][3*i+0]=red;
<a name="l00282"></a>00282         image[j][3*i+1]=green;
<a name="l00283"></a>00283         image[j][3*i+2]=blue;
<a name="l00284"></a>00284       }
<a name="l00285"></a>00285     }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287     <span class="keywordtype">char</span> fmesh[256],desc[256];
<a name="l00288"></a>00288     ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s_%01i.%04i.%i.png&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,2,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,mcomp);CHKERRQ(ierr);
<a name="l00289"></a>00289     ierr = PetscSNPrintf(desc,255,<span class="stringliteral">&quot;t=%g ns, Etot=%g (J/m^3)&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9,gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>);CHKERRQ(ierr);
<a name="l00290"></a>00290     <a class="code" href="writepng_8c.html#a7770d19aebe21e0a423fd40781030bcb">WritePNGfile</a>(fmesh,pix[0],pix[1],image,desc);
<a name="l00291"></a>00291   }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   VecRestoreArray(VIpol,&amp;a);
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   ierr = PetscFree(image[0]);CHKERRQ(ierr);
<a name="l00296"></a>00296   ierr = PetscFree(image);CHKERRQ(ierr);
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

